      implicit double precision (a-h,o-z) 
      parameter(neq=24,nflux=24,jmax=6000,inner=500) 
      dimension y(neq),dy(neq) 
      dimension flux(nflux) 
 
c     Initialize variables 
 
      y(1) = 0.07928            !AcoA 
      y(2) = 0.2957             !CIT 
      y(3) = 0.1242             !ISOC 
      y(4) = 0.04714            !aKG 
      y(5) = 0.4714             !SCoA 
      y(6) = 0.3505             !SUC 
      y(7) = 0.1028             !FUM 
      y(8) = 0.04383            !MAL 
      y(9) = 0.0005             !OAA 
      y(10) = 0.483             !asp 
      y(11) = 8.0               !glu 
      y(12) = 9.450E-05     	!Cam
      y(13) = 0.670             !Mg 
      y(14) = 0.132             !CoA 
      y(15) = 1.3	        !ADP 
      y(16) = 1.0               !NAD  
      y(17) = 1.0               !NADH 
      y(18) = 10**(-7.2)        !H (M) 
      y(19) = 0.0               !CO2 
      y(20) = 160.0             !Psi 
      y(21) = 0.050             !FADH2 
      y(22) = 0.0001         	!Cai
      y(23) = 5.1         	!Nam (mM)
      y(24) = 1.0               !Pimito (mM)
 
c     Initialize variable from restart file 
      irestart = 1 
      if (irestart.eq.1) then 
        open (unit=20,file='restart.init') 
        read (20,310) (y(k),k=1,neq) 
        close (unit=20) 
      endif 
 
      do k=1,neq 
         dy(k) = 0.0 
      enddo 
      do k=1,nflux 
         flux(k) = 0.0 
      enddo 
      t = 0.0 
      dt = 0.02 	! ms
      etol = 1.0d-12 
      emintol = 1.0d-14 
c     write concentration starting with t=0 
      write (8,300) t,(y(k),k=1,5) 
      write (9,300) t,(y(k),k=6,10) 
      write (10,300) t,(y(k),k=11,15) 
      write (11,300) t,(y(k),k=16,20) 
      write (16,300) t,(y(k),k=21,24) 

c     Start integration 
      do 15 m=1,jmax 
    2    do 10 i=1,inner 	!for s and ms
c	 read (5,*) eki1,eki2,eki3,eki4,eki5,eki6
c	 y(22) = (eki3*1.0+eki5*0.0)/1000.0
            call rk4am(y,t,dy,dt,etol,emintol,neq,flux,nflux) 
   10    continue 
         t = dfloat(m*inner)*dt
	 tsec = t/1000.0
c        write concentration values
c	 write (6,*) tsec, y(12),eki3/1000.0,eki5/1000.0,y(22)
         write (8,300) tsec,(y(k),k=1,5) 
         write (9,300) tsec,(y(k),k=6,10) 
         write (10,300) tsec,(y(k),k=11,15) 
         write (11,300) tsec,(y(k),k=16,20) 
         write (16,300) tsec,(y(k),k=21,24) 

c        write flux values 
         write (12,300) tsec,(flux(k),k=1,5) 
         write (13,300) tsec,(flux(k),k=6,10) 
         write (14,300) tsec,(flux(k),k=11,15) 
         write (15,300) tsec,(flux(k),k=16,20)         
         write (20,300) tsec,(flux(k),k=21,24)

   15 continue 
  200 open (unit=20,file='restart.dat') 
      write (20,310) (y(k),k=1,neq) 
      close (unit=20) 
  300 format(8(1x,1pe12.5)) 
  310 format(30(1x,1pe12.5)) 
      stop 
      end 
